#ifndef SBK_KHelpMenuWrapper_H
#define SBK_KHelpMenuWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <khelpmenu.h>

namespace PySide { class DynamicQMetaObject; }

class KHelpMenuWrapper : public KHelpMenu
{
public:
    KHelpMenuWrapper(const KHelpMenuWrapper &) = delete;
    KHelpMenuWrapper& operator=(const KHelpMenuWrapper &) = delete;
    KHelpMenuWrapper(KHelpMenuWrapper &&) = delete;
    KHelpMenuWrapper& operator=(KHelpMenuWrapper &&) = delete;

    KHelpMenuWrapper(::QWidget * parent = nullptr);
    KHelpMenuWrapper(::QWidget * parent, const ::QString & unused, bool showWhatsThis = true);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void timerEvent(::QTimerEvent * event) override;
    ~KHelpMenuWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_KHelpMenuWrapper_H

